﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Drawing;
using System.Windows.Forms;

namespace EAA
{
    class Hysteresis
    {
        public Output output { get; set; }
        public PictureBox Pic { get; set; }
        public Hysteresis(Output outp, PictureBox pic)
        {
            this.output = outp;
            this.Pic = pic;
        }
        public bool Readfile(out List<double> B, out List<double> H)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "lab files (*.lab)|*.lab|All files (*.*)|*.*";
            B = new List<double>();
            H = new List<double>();
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                string text = "";
                StreamReader reader = new StreamReader(ofd.FileName);
                int stopCount = 0;
                do
                {
                    stopCount++;
                    text = reader.ReadLine();
                    if (stopCount == 100 || text == null)
                    {
                        output.Write("Error: File has the wrong format!");
                        return false;
                    }
                } while (text.IndexOf("Magn.") < 0);
                for (int i = 0; i < 3; i++)
                    reader.ReadLine();

                // read columns rows
                string[] tokens = reader.ReadLine().Split(' ');
                if (tokens.Length < 2)
                {
                    return false;
                }
                int rowCount, colCount;

                int.TryParse(tokens[0], out colCount);
                int.TryParse(tokens[1], out rowCount);
                string[] textFromFile = new string[rowCount];
                List<double> current = new List<double>();
                List<double> b = new List<double>();

                for (int j = 0; j < rowCount; j++)
                {
                    Array.Clear(tokens, 0, tokens.Length);
                    string[] token = new string[3];
                    string line = reader.ReadLine();
                    token = line.Split('\t');
                    current.Add(Convert.ToDouble(token[2].Replace('.', ',')));
                    b.Add(Convert.ToDouble(token[3].Replace('.', ',')));
                }
                double N = 250, l = 0.07;
                List<double> h = new List<double>();
                for (int i = 0; i < b.Count; i++)
                {
                    h.Add((N * current[i]) / l);
                }
                H = h;
                B = b;
                return true;
            }
            return false;
        }
        public bool DrawHysterese(Graphics g, List<double> b, List<double> h, bool showAxes)
        {

            if (b.Count > 1)
            {
                float xmid = Pic.Width / 2f, ymid = Pic.Height / 2f, mult = 0.1f, multb = 5 * 0.14f;


                //axes
                //if (Properties.Settings.Default.showAxis)
                //{
                //    g.DrawLine(Pens.Red, xmid - 100, ymid, xmid + 100, ymid);
                //    g.DrawLine(Pens.Red, xmid, ymid - 100, xmid, ymid + 100);
                //}
                // draw hysterese
                int quaterIndex = (h.Count / 4);
                //List<float> deltaB = new List<float>();
                //List<float> deltaH = new List<float>();

                for (int i = 0; i < 2 * quaterIndex - 1; i++)
                {
                    float deltaB; //in Pixel
                    deltaB = (float)((b[i] - b[b.Count - i - 1]) * mult);
                    g.DrawLine(Pens.LightBlue, xmid + ((float)(h[i] * mult)), ymid - (float)(b[i] * multb), (xmid + ((float)(h[h.Count - i - 1] * mult))), (ymid - (float)(b[b.Count - i - 1] * multb)));
                }
                for (int i = 0; i < b.Count - 1; i++)
                {
                    g.DrawLine(Pens.Black, xmid + ((float)(h[i] * mult)), ymid - (float)(b[i] * multb), xmid + ((float)(h[i + 1] * mult)), ymid - (float)(b[i + 1] * multb));
                }
                g.DrawString("A", new Font("", 8, FontStyle.Italic), Brushes.Coral, xmid - 5, ymid - 5);
                return true;
            }

            return false;
        }
        public double CalcArea(List<double> x, List<double> y)
        {
            int quaterIndex = (x.Count / 4);
            double area = 0;

            for (int i = 0; i < 2 * quaterIndex - 1; i++)
            {
                double dx = x[i + 1] - x[i];
                double dy = y[y.Count - 1 - i] - y[i];
                double area2 = Math.Abs(dx * dy);
                area += area2;
            }
            return area;
        }



    }
}
